<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:file="java:java.io.File">
	<xsl:output method="html" indent="yes"/>

	<xsl:template match="/">
		<xsl:variable name="file-name" select="file:getName(file:new(string(base-uri())))"/>
		<html>
			<head>
				<title>Usage of elements in file <xsl:value-of select="$file-name"/></title>
				<style type="text/css">
					<xsl:comment>
						a { text-decoration:none; font-weight:normal; white-space:nowrap; }
						ul { margin-top:-1; margin-bottom:-1;}
					</xsl:comment>
				</style>
			</head>
			<body>
				<h2>Usage of elements in file <i><xsl:value-of select="$file-name"/></i></h2>
				<xsl:variable name="all-elements" select="//*"/>
				<xsl:variable name="root-element" select="node-name(/*[1])"/>
				<b><xsl:value-of select="count(distinct-values(for $n in $all-elements return string(node-name($n))))"/> unique elements with <xsl:value-of select="count($all-elements)"/> total occurrences found</b>:
				<ul>
				<xsl:for-each-group select="$all-elements" group-by="string(node-name())">
					<xsl:sort select="string(node-name())"/>
					<li>
     					<b><xsl:value-of select="node-name()"/></b>: <b><xsl:value-of select="count(current-group())"/></b> occurence(s)
     					<xsl:variable name="current-element" select="node-name(current())"/>
     					<xsl:choose>
                        <xsl:when test="$current-element!=$root-element">
                        <ul>
               				<xsl:for-each-group select="$all-elements[*[node-name(.)=$current-element]]" group-by="string(node-name())">
					            <xsl:sort select="string(node-name())"/>
					            <li>
					                in <b><xsl:value-of select="node-name()"/></b>: <b><xsl:value-of select="count(current-group()/*[node-name(.)=$current-element])"/></b> occurrence(s)
					            </li>
					        </xsl:for-each-group>
                        </ul>
                        </xsl:when>
                        <xsl:otherwise><li>this is the <b>root</b> element</li></xsl:otherwise>
                        </xsl:choose>
					</li>
				</xsl:for-each-group>
				</ul>
			</body>
		</html>
	</xsl:template>
</xsl:stylesheet>
