<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:file="java:java.io.File">
	<xsl:output method="html" indent="yes"/>

	<xsl:template match="/">
		<xsl:variable name="file-name" select="file:getName(file:new(string(base-uri())))"/>
		<html>
			<head>
				<title>Usage of elements in file <xsl:value-of select="$file-name"/></title>
				<style type="text/css">
					<xsl:comment>
						a { text-decoration:none; font-weight:normal; white-space:nowrap; }
						ul { margin-top:-1; margin-bottom:-1;}
					</xsl:comment>
				</style>
			</head>
			<body>
				<table border="1">
				<tr><th colspan="4">Usage of elements in file <code><xsl:value-of select="$file-name"/></code></th></tr>
				<tr><th>Child-Element</th><th>Occurrences (total)</th><th>Parent-Element</th><th>Occurrences</th></tr>
				<xsl:variable name="all-elements" select="//*"/>
				<xsl:variable name="root-element" select="node-name(/*[1])"/>
				<xsl:for-each-group select="$all-elements" group-by="string(node-name())">
					<xsl:sort select="string(node-name())"/>
     					<xsl:variable name="current-element" select="node-name(current())"/>
     					<xsl:variable name="element-count" select="count(current-group())"/>
                        <xsl:choose>
                        <xsl:when test="$current-element!=$root-element">

               				<xsl:for-each-group select="$all-elements[*[node-name(.)=$current-element]]" group-by="string(node-name())">
					            <xsl:sort select="string(node-name())"/>
					            <tr>
					                <td><xsl:value-of select="$current-element"/></td>
					                <td><xsl:value-of select="$element-count"/></td>
					                <td><xsl:value-of select="node-name()"/></td>
                                    <td><xsl:value-of select="count(current-group()/*[node-name(.)=$current-element])"/></td>
					            </tr>
					        </xsl:for-each-group>
                        </xsl:when>
                        <xsl:otherwise>
                            <tr><td><xsl:value-of select="$current-element"/></td><td>1</td><td>(root element)</td><td>-</td></tr>
                        </xsl:otherwise>
                        </xsl:choose>
				</xsl:for-each-group>

				<tr>
					<td colspan="2">unique elements: <xsl:value-of select="count(distinct-values(for $n in $all-elements return string(node-name($n))))"/></td>
                    <td colspan="2">total elements: <xsl:value-of select="count($all-elements)"/></td>
				</tr>
				</table>
			</body>
		</html>
	</xsl:template>
</xsl:stylesheet>
